#ifndef COMMONCONFIG_H
#define COMMONCONFIG_H

typedef float _float;

#include <stdexcept>
#include <cstdint>

#define __DEFAULTRANDOMGENERATOR__ /*!< Uses the default random generator, otherwise uses the \c std::mersenne_twister_engine >*/

#define UNIVERSE_AGE_IN_SEC 4.3611707664e+17

#define PI 3.141592653589793

#define TIME_EPSILON 1e-9 // 1 ns
#define FREQ_EPSILON 1e9 // 1 GHz


/*!
 * \brief Supress warnings coming from an unused variable.
 */
template <typename T>
void ignore(T &&)
{ }

#endif // COMMONCONFIG_H
