/*
 ============================================================================
 Project    : Parallel Genetic Algorithm for the SUPBR Problem
                (version with multiple populations)
 File       : GerarPopuInicial.c
 Author     : Lucas Silveira
                Group of Theory of Computation
                Universidade de Brasilia (UnB) - Brazil
 ============================================================================
 */

#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "structure.h"



void mostrar_poblacion(population *pob, int tamanho){
    
    int i,j;
    //imprimir poblacion actual
    for(i=pob->basePopulation; i<pob->topPopulation; i++){
        printf("(%d): ",i);
        for(j=0; j<tamanho; j++){
            printf("%d, ", pob->genome[i].genes[j]);
        }
        printf("\n");
    }
    
}

//o rank representa o processo
void CarregarPopInitial(int world_rank, float porcentaje_reemp,  float porcentaje_selec, population *pob, permutation *perm){
	int i, j=0, valor;
    FILE *arq;
    if (world_rank==0)
    {
        arq = fopen("P0", "r");   
    }

    else if (world_rank==1)
    {
        arq = fopen("P1", "r");   
    }


    else if (world_rank==2)
    {
        arq = fopen("P2", "r");   
    }
    else if (world_rank==3)
    {
        arq = fopen("P3", "r");   
    }
    else if (world_rank==4)
    {
        arq = fopen("P4", "r");   
    }

   else if (world_rank==5)
    {
        arq = fopen("P5", "r");   
    }

   else if (world_rank==6)
    {
        arq = fopen("P6", "r");   
    }

   else if (world_rank==7)
    {
        arq = fopen("P7", "r");   
    }

   else if (world_rank==8)
    {
        arq = fopen("P8", "r");   
    }

   else if (world_rank==9)
    {
        arq = fopen("P9", "r");   
    }

   else if (world_rank==10)
    {
        arq = fopen("P10", "r");   
    }

   else if (world_rank==11)
    {
        arq = fopen("P11", "r");   
    }

   else if (world_rank==12)
    {
        arq = fopen("P12", "r");   
    }

   else if (world_rank==13)
    {
        arq = fopen("P13", "r");   
    }

  else if (world_rank==14)
    {
        arq = fopen("P14", "r");   
    }

  else if (world_rank==15)
    {
        arq = fopen("P15", "r");   
    }

  else if (world_rank==16)
    {
        arq = fopen("P16", "r");   
    }

  else if (world_rank==17)
    {
        arq = fopen("P17", "r");   
    }
 
  else if (world_rank==18)
    {
        arq = fopen("P18", "r");   
    }

  else if (world_rank==19)
    {
        arq = fopen("P19", "r");   
    }

  else if (world_rank==20)
    {
        arq = fopen("P20", "r");   
    }

  else if (world_rank==21)
    {
        arq = fopen("P21", "r");   
    }

  else if (world_rank==22)
    {
        arq = fopen("P22", "r");   
    }

  else
    {
        arq = fopen("P23", "r");   
    }




    if(arq == NULL)
    {
        printf("Erro, nao foi possivel abrir o arquivo\n");
        exit(0);
    }
    else
    {
        fscanf(arq,"%d", &perm->size);
        fscanf(arq,"%d", &pob->sizePopulation);//for each individual
        pob->basePopulation = 0;
        pob->topPopulation = pob->sizePopulation;
        pob->limiteSelection = pob->sizePopulation * porcentaje_selec;//limite de pob q seran "seleccionados" para crossover
        pob->baseReplace = pob->sizePopulation * porcentaje_reemp;//base de pob a partir de donde se hara el reemplazo
        
        pob->baseDescendencia = pob->sizePopulation;
        pob->topeDescendencia = pob->sizePopulation + pob->limiteSelection;
        pob->sizeTotal = pob->topeDescendencia;// tamanho total = poblacion + descendencia
        /*alocar memoria*/
        pob->genome = (Genome*)malloc(pob->sizeTotal*sizeof(Genome)); //alocar memoria para poblacion total
        if (pob->genome == NULL)
            printf("pob->genome NULL in poblacion_inicial() \n");
        for(i=0;i<pob->sizeTotal;i++){
            pob->genome[i].genes = (int*)malloc(perm->size * sizeof(int));//alocar memoria para cada cromosoma
            if (pob->genome[i].genes == NULL)
                printf("pob->genome[i].genes NULL in poblacion_inicial() \n");
        }
        
         while (j<pob->sizePopulation)
         {
             
             
             for (i=0; i<perm->size; i++)
            {
                
                fscanf(arq,"%d", &valor);
                pob->genome[j].genes[i] = valor;
            }//end for
             
            pob->genome[j].size = perm->size;
            j++;
             
             
         }//end while
        
        for(i=pob->baseDescendencia; i<pob->topeDescendencia; i++){
            pob->genome[i].size = perm->size;
        }
         
         
       //  mostrar_poblacion(pob, perm->tamanho);
       
        
    }//else
    fclose(arq);
}




int * read_permutation_of_file(const char* name, permutation *perm)
{
    int i,n;
    int * identity=NULL;
    FILE *filePointer;
    if ((filePointer = fopen(name,"r")) == NULL){
        printf("qual no nome do arquivo %s\n", name);
        printf("Warning File not found\n");
    }
    
    else
    {
        //read size of permutation
        fscanf(filePointer,"%d",&n);
        perm->size = n;
        //alocate memory for perm->pi
        perm->pi = (int*)malloc(perm->size*sizeof(int));
        //leer permutacion
        for(i=0; i<n; i++)
        {
            fscanf(filePointer,"%d",&perm->pi[i]);
        }
        fscanf(filePointer,"%d",&n);
        identity= (int *) calloc (n, sizeof (int));
        for(i=0; i<n; i++)
        {
            fscanf(filePointer,"%d",&identity[i]);
        }
        
        
    }//end  else
    fclose(filePointer);
    
    return identity;
}//end read permutation of archivo




//processo de debug
//Passa a quantidade de processadores a ser utilizado
void construirPopInit(int P, population *pob, int n, permutation *perm){
    int i, j, k, contador;
    i=0;
    FILE *fp;
    int conta_ind=0;
    int tamanhoPop=(int) (n * (log(n) / log(2))); //tamanho de la poblacion = (nlogn), log base 2
   
    for (contador=0; contador<P; contador++)
    {
        
        
        if(contador==0)
        {
            fp = fopen("P0", "w");
        }
        
        
        else if(contador==1)
        {
            fp = fopen("P1", "w");
        }
        
        else if(contador==2)
        {
            fp = fopen("P2", "w");
        }
        
        else if (contador==3)
        {
            fp = fopen("P3", "w");
        }
        
        else if (contador==4)
        {
            fp = fopen("P4", "w");
        }
        
        else if (contador==5)
        {
            fp = fopen("P5", "w");
        }
        
        else if (contador==6)
        {
            fp = fopen("P6", "w");
        }
        
        else if (contador==7)
        {
            fp = fopen("P7", "w");
        }
        
        
        else if (contador==8)
        {
            fp = fopen("P8", "w");
        }
        
        else if (contador == 9)
        {
            fp = fopen("P9", "w");
            
        }
        
        else if (contador == 10)
        {
            fp = fopen("P10", "w");
        }
        
        else if (contador == 11)
        {
            fp = fopen("P11", "w");
        }
        
        else if (contador == 12 )
        {
            fp = fopen("P12", "w");
        }
        
        else if (contador == 13)
        {
            fp = fopen("P13", "w");
        }
        
        
        else if (contador == 14)
        {
            fp = fopen("P14", "w");
        }
        
        else if (contador == 15)
        {
            fp = fopen("P15", "w");
        }
        
        else if (contador == 16)
        {
            fp = fopen("P16", "w");
        }
        
        else if (contador == 17)
        {
            fp = fopen("P17", "w");	
        }
        
        else if (contador == 18)
        {
            fp = fopen("P18", "w");
        }
        
        else if (contador == 19)
        {
            fp = fopen("P19", "w");
        }
        
        
        else if (contador == 20)
        {
            fp = fopen("P20", "w");
        }
        
        else if (contador == 21)
        {
            fp = fopen("P21", "w");
        }
        
        else if (contador == 22)
        {
            fp = fopen("P22", "w");
        }
        else
        {
            fp = fopen("P23", "w");
        }
        
        if (fp != NULL)
        {
            fprintf(fp,"%d\n",n);// tamanho da permutacao
            fprintf(fp,"%d\n",((int)(n * (log(n) / log(2)))));// tamanho da populacao
            for(k=0; k < tamanhoPop; k++)
            {
                for(j = 0; j < n; j++)
                {
                    fprintf(fp,"%d\n",pob->genome[i].genes[conta_ind]);
                    conta_ind++;
                }//end for j
                i++;
                conta_ind=0;
            }//end for i1
            fclose(fp);
        }//end if
        else
        {
            printf("Falha ao criar o Arquivo");
            exit(1);
        }

    }// end for
    

        
        
    
}
/*

int main(int argc,char **argv)
{
    int seed2=atoi(argv[1]);
    //int numeroProcessadores=atoi(argv[2]);
    srand (seed2);//initialize random generator
    
    
    poblacion pob;
    permutacion perm;
    construirPopInit(4, 2, &pob, &perm);
    leer_permutacion_de_archivo("i", &perm);
   CarregarPopInitial(2, 0.5, 0.8, &pob,&perm);
    return 0;
}
 
*/
