﻿/*
 ============================================================================
 Project    : Parallel Genetic Algorithm for the SUPBR Problem
                (version with multiple populations)
 File       : GerarPopuInicial.c
 Author     : Lucas Silveira
                Group of Theory of Computation
                Universidade de Brasilia (UnB) - Brazil
 ============================================================================
 */

#ifndef POPINIT_h
#define POPINIT_h

#include <string>

#include "structure.h"

using namespace std;

void mostrar_poblacion(population *pob, int tamanho);

//o rank representa o processo
void CarregarPopInitial(int world_rank, float porcentaje_reemp,  float porcentaje_selec, population *pob, permutation *perm);

int * read_permutation_from_file(const char* name, permutation *perm);

//processo de debug
//Passa a quantidade de processadores a ser utilizado
void construirPopInit(int P, population *pob, int n, permutation *perm);

#endif
