/*
 ============================================================================
 Project     : Fitness Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include "Additionaldata.c"

 int capping1= 0; // boolean to decide if the genomes need to be capped
 //private CappedGenomes   cappedGenomes = null;
//int *compDistances;
int size_compDistances;
int numberOfCycles;//variables of count the amount of cycles black


//initialize variables
void S_genomeLength(){
     size_compDistances=0;
     numberOfCycles = 0;
    
}//end of the S_genomeLength



 int * copiar_cromossomo(int i, int j, int status){
        int k=0;
	int *array=(int *) calloc (j+1, sizeof (int));
	if(status==1)//genoma A
	{	for(;k<=j;k++)
		{

			array[k]=GENOMA_A[i][k];
				
		}//fim for
	}//fim if
	else
	{
		for(;k<=j;k++)
		{

			array[k]=GENOMA_B[i][k];
				
		}//fim for
		

	}//fim else


       return array;
 	

}// end of the functions



int abstractGene(int gene, int left) {
        /* Entry is either right, thus a tail if > 0 or left, thus a tail if < 0 */
	//printf("gene %d %d \n",gene, left);        
	if ((gene <= 0 && left==0) || (gene >= 0 && left==1)) {
	//printf("%d\n",2 * abs(gene));            
	return 2 * abs(gene);
        }
        // else : Entry is either right, thus a tail if < 0 or left, thus a tail if > 0
	//printf("%d\n",2 * abs(gene) - 1);        
	return 2 * abs(gene) - 1;
    }





//status indica se eh para o genoma A ou B
 int * parseAdjacencies(int status, int entrada[],int size)
{	int i;
	int j;
	int geneNumberLeft;
    int geneNumberRight;
	int length;
    int * genomeAdjacencies =(int *) calloc (2 * qtd_genes + 1, sizeof (int));
    if (genomeAdjacencies==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, AdacencyGraph.C, LINE 86\n");
    }
    int *estatus;
    if(status==1)
        estatus=status_A(entrada, size);
    else
        estatus=status_B(entrada, size);
    if (estatus==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, AdacencyGraph.C, LINE 94\n");
    }
   
	if(status==1)//genoma A
    {

	for ( i = 0; i < qtd_cromossomo; ++i) {
	   
            //aux=copiar_cromossomo(i, estatusA[i], 1);//variable aux is global and it is with reference to a chromosome
        
            length =estatus[i];
       
            // Part for processing telomeres, thus we choose "false" as input for "abstractGene"
            geneNumberLeft =abstractGene(GENOMA_A[i][0], 0);// 0 represents the Boolean value false
            geneNumberRight = abstractGene(GENOMA_A[i][estatus[i]-1], 1); // Right telomere is left in adjacency:
                                                                   // true
		//verification if is circular, 1 true, 0 false
		
            if (GENOMA_A[i][length]==1) {
		        printf("sou circular %d\n",GENOMA_A[i][length]);
                genomeAdjacencies[geneNumberLeft] = geneNumberRight;
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
                // can already save telomere entries
            } else {
                genomeAdjacencies[geneNumberLeft] = geneNumberLeft;
                genomeAdjacencies[geneNumberRight] = geneNumberRight;
            }

            for (j= 1; j < estatus[i]; ++j) {
                geneNumberLeft = abstractGene(GENOMA_A[i][j - 1], 1);//1 true
                geneNumberRight = abstractGene(GENOMA_A[i][j], 0);//0 false
               // printf(" valor de geneNumberLeft %d e geneNumberRight %d \n",geneNumberLeft,geneNumberRight);
                genomeAdjacencies[geneNumberLeft] = geneNumberRight; // save
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
            }
	
        }
         
    }//fim do status 1
  else
  {	 
       for ( i = 0; i < qtd_cromossomo; ++i) {
           
            //aux=copar_cromossomo(i, estatusB[i], 2);//variable aux is global and it is with reference to a chromosome
		
	     length =estatus[i];
	    // Part for processing telomeres, thus we choose "false" as input for "abstractGene"
            geneNumberLeft =abstractGene(GENOMA_B[i][0], 0);// 0 represents the Boolean value false
            geneNumberRight = abstractGene(GENOMA_B[i][estatus[i]-1], 1); // Right telomere is left in adjacency:
            //printf("geneNumberLeft:%d\n",geneNumberLeft);
            //printf("geneNumberRight:%d\n",geneNumberRight);                                                                     // true
		//verification if is circular, 1 true, 0 false
            if (GENOMA_B[i][length]==1) {
		printf("entrei nesse circular %d\n",GENOMA_B[i][length]);
                genomeAdjacencies[geneNumberLeft] = geneNumberRight;
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
                // can already save telomere entries
            } else {
                genomeAdjacencies[geneNumberLeft] = geneNumberLeft;
                genomeAdjacencies[geneNumberRight] = geneNumberRight;
            }//fim else

            for (j= 1; j < estatus[i]; ++j) {
                geneNumberLeft = abstractGene(GENOMA_B[i][j - 1], 1);//1 true
                geneNumberRight = abstractGene(GENOMA_B[i][j], 0);//0 false

                genomeAdjacencies[geneNumberLeft] = geneNumberRight; // save
                genomeAdjacencies[geneNumberRight] = geneNumberLeft;
            }// end for
	
        }//end for
  	
  				
   }//else for status 2
	
 free(estatus);
return genomeAdjacencies;

}//end of the parseAdjacencies

// return a array of integer what represent values boolean
int * calculatePathsAndCycles(int entrada[], int entrada2[], int size){
    size_compDistances=0;
   int compDistances[2 * qtd_genes + 1];
	int * adjacenciesGenome1=parseAdjacencies(1,entrada, size);
    if (adjacenciesGenome1==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, AdacencyGraph.C, LINE 180\n");
    }
    int * adjacenciesGenome2=parseAdjacencies(2, entrada2, size);
    if (adjacenciesGenome2==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, AdacencyGraph.C, LINE 184\n");
    }
    int * belongToEvenP=(int *) calloc (2 * qtd_genes + 1, sizeof (int));
    if (belongToEvenP==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, AdacencyGraph.C, LINE 188\n");
    }
    int edgesCount = 0;
    int visited[2 * qtd_genes + 1];// representa boolean
    int numberOfOddPaths = 0;
	numberOfCycles=0;//global variable 
        int i;
	//printf("adjacenciesGenome2**************\n");
	for(i=0;i<(2 * qtd_genes + 1);i++)
	{	visited[i]=0;
    		 //printf("%d,",adjacenciesGenome2[i]);
      
    	}
    for (i = 1; i < (2 * qtd_genes + 1); ++i) {
        
        //printf("valor de visited %d\n",visited[i]);
        if (!visited[i]) {
            visited[i] = 1; // i was now visited
            int choose1stGenome = 0; // chooses target genome of current edge
            int extremityPath1 = i;
            int extremityPath2 = i;
            int nextExtremityPath1 = 0;
            int nextExtremityPath2 = 0;
            ++edgesCount;
            nextExtremityPath1 = adjacenciesGenome1[i]; // get next extremities
            nextExtremityPath2 = adjacenciesGenome2[i];
            
             
            
            while ((!visited[nextExtremityPath1]) && (nextExtremityPath1 != extremityPath1)) {
               // printf("entrei no primeiro while %d\t",extremityPath1);
                
                visited[nextExtremityPath1] = 1;
                ++edgesCount;
                extremityPath1 = nextExtremityPath1;
              //  printf("modificou extremityPath1 %d\t",extremityPath1);
                
                
                if (choose1stGenome) { // chooses target genome of current edge
                    nextExtremityPath1 = adjacenciesGenome1[extremityPath1];
                   // printf("modificou no if nextExtremityPath1 com adjancegenome1 %d posicao %d\t",nextExtremityPath1,extremityPath1);
                    choose1stGenome = 0;//representing false
                    //printf("modificou choose1stGenome %d\t",choose1stGenome);
                }
                else
                {
                   // printf("estou no else \n");
                    nextExtremityPath1 = adjacenciesGenome2[extremityPath1];
                    //printf("eu sou nextExtremityPath1 de adjacegnome2 %d na posicao %d\n",choose1stGenome,extremityPath1);
                    choose1stGenome = 1;//representing true
                   // printf("eu sou choose1stGenome %d\n",choose1stGenome);
                }
            } // path1 is finished, now walk along path2 if path1 was not a cycle
           
            
            if ((extremityPath2 == nextExtremityPath1) && (extremityPath1 != extremityPath2)) {
                 // check if path1 is a cycle
                compDistances[size_compDistances]=(edgesCount - 2) / 2;
                size_compDistances++;
                ++numberOfCycles;
            
            }//end of the if
            
            else {
                choose1stGenome = 1;//representing true
                while (nextExtremityPath2 != extremityPath2) {
                  //  printf("estou no segundo while\n");
                    
                    visited[nextExtremityPath2] = 1; // can't be circular anymore
                    //printf("visited[nextExtremityPath2] update em %d\n",nextExtremityPath2);
                    ++edgesCount;
                    extremityPath2 = nextExtremityPath2;
                      ///  printf("modifiquei extremityPath2 %d\n",extremityPath2);
                    
                    if (choose1stGenome) {
                       // printf("entrei no if choose1stgenome \n");
                        nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                       // printf("modifiquei nextExtremityPath2 %d com valor de adjacgnome1 na pos %d\n",nextExtremityPath2,extremityPath2);
                        choose1stGenome = 0;//representing false
                       // printf("setei choose1stgenome %d\n",choose1stGenome);
                        
                    }
                    
                    else {
                        //printf("entrei no else choose1stgenome \n");
                        nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                        choose1stGenome = 1;//representing true
                        //printf("modifiquei nextExtremityPath2 %d com valor adjacegenom2 posciao %d\n",nextExtremityPath2, extremityPath2);
                        //printf("setei choose1stgenome %d\n",choose1stGenome);
                    }
                }//end while
                
                if (edgesCount % 2 == 0) {
                    //printf("edgesCount 2 = 0 %d\n",edgesCount);
                    compDistances[size_compDistances]=edgesCount / 2;
                    size_compDistances++;
                    // update array saving true if an an extremity belongs to an even path
                    
                    belongToEvenP[extremityPath2] = 1;//representing true
                  //  printf("atualizando belongtoEvenp na posi %d\n",extremityPath2);
                    
                  //  printf("if (choose1stGenome) %d\n",choose1stGenome);
                    
                    if (choose1stGenome) {
                        
                        nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                        choose1stGenome = 0;//representing false
                    }//end if
                    
                    else {
                        nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                        choose1stGenome = 1;//representing true
                    }//end else
                    
                    
                    while (nextExtremityPath2 != extremityPath2) {
                       // printf("estou no terceiro while\n");

                        extremityPath2 = nextExtremityPath2;
                        //printf("extremityPath2 %d\n",extremityPath2);

                        belongToEvenP[extremityPath2] = 1;//representing true
                      //  printf("atualizando belongtovenp na posi %d\n",extremityPath2);
                        
                        if (choose1stGenome) {
                           // printf("entrei no if do choose1stGenome\n");
                            
                            nextExtremityPath2 = adjacenciesGenome1[extremityPath2];
                            choose1stGenome = 0;//representing false
                        }
                        
                        else {
                            nextExtremityPath2 = adjacenciesGenome2[extremityPath2];
                            //printf(" no senao nextExtremityPath2 referente ao adjanceigenome2  %d\n",nextExtremityPath2);
                            
                            choose1stGenome =1;//representing true
                        }
                    }//end while
                    
                    // Capping for even paths
                    
                    if (capping1) {
                        //printf(" no if do capping faz nada aqui \n");
                        int firstGenome = choose1stGenome;
                        firstGenome=firstGenome*1;
                        
                       
                    }
                }
                else {
                    
                   // printf("no else contrario ao capping\n");
                    compDistances[size_compDistances]=(edgesCount - 1) / 2;
                   // printf(" ataulizando compdistantces  na posicao %d para %d\n",size_compDistances,(edgesCount - 1) / 2);
                    
                    size_compDistances++;
                    ++numberOfOddPaths;
                    // Capping for odd paths
                    if (capping1) {
                         int firstGenome = choose1stGenome;
                         firstGenome=firstGenome*1;
                       }//end if
                }//end else
            }//end else
            edgesCount = 0;
            //  printf("zerei edgesCount e vamu comecar de novo \n");
        }//end if, the first if what appear
    }//fim do for
	
 free(adjacenciesGenome1);//nao posso da free nisso aqui
 free(adjacenciesGenome2);// nem nesse
return belongToEvenP;
}//end




void adjacencygraph(int entrada[],int entrada2[], int size){
    S_genomeLength();
	 parseAdjacencies(2,entrada2, size);//genoma A
	
   // calculatePathsAndCycles( entrada,entrada2,  size);

	

}

/*
int main(){

	   // usa-se o 0 para separar os cromossomos no genoma
	int entrada[11]={4,3,0,1,2,-7,5,0,6,-8,9};
    int entrada2[11]={1,2,3,0,4,5,0,6,7,8,9};
    
	//printf("Saida: %d \n", cromossomo(entrada,entrada2, (sizeof(entrada)/sizeof(int)),(sizeof(entrada2)/sizeof(int)))); 
	printf("saida:%d\n",is_cotail( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)))); 
    load_genoma( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)));
	adjacencygraph(entrada,entrada2,(sizeof(entrada)/sizeof(int)));



    return 0;
}

*/
