/*
 ============================================================================
 Project     : Fitness Algorithm
 Author      : Lucas Angelo Silveira
 Universidade de Brasilia (UnB) - Brazil
 Group of Theory of Computation
 Version     : 1.0
 
 Last Modified On: July 16, 2015.
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
int qtd_cromossomo;//quantia de cromossomo
int qtd_genes;
int GENOMA_A[22][201];//suporta ate 200 cromossomos com 200 genes em cada,a ultima posicao de cada cromossomo guarda se ele eh circular
int GENOMA_B[22][201];// o mesmo aplicado a GENOMA_A aplica-se ao B




int is_cotail(int entrada[],int entrada2[],int size, int sizeB)
{
    int i=0;
   
    //tem que ter o mesmo numero de genes
    if (size !=sizeB) {
        return 0;
    }
    
    //arrays para verificar se os genomas sao co-taild
    int * conjuntoA=(int *) calloc (size, sizeof (int));
    if (conjuntoA==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, VALIDAENTRADA.C, LINE 31\n");
    }
    int *conjuntoB=(int *) calloc (size, sizeof (int));
    if (conjuntoB==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, VALIDAENTRADA.C, LINE 34\n");
    }
    
    for (; i<size; i++) {
        
        conjuntoA[i]=0;
        conjuntoB[i]=0;
    }
    
    conjuntoA[abs(entrada[0])]=entrada[0];
    conjuntoB[abs(entrada2[0])]=entrada2[0];
    
    
    for (i=1; i<size; i++) {
        
            
        if(i+1 <size && entrada[i+1]==0 )
            conjuntoA[abs(entrada[i])]= -1* entrada[i];
        
        else  if(i+1==size)
            conjuntoA[abs(entrada[i])]=-1*entrada[i];
        
        else if(i>1 && entrada[i-1]==0)
            conjuntoA[abs(entrada[i])]=entrada[i];
        
        else
        {
            if (entrada[i]==0 && conjuntoA[i]==0) {
                conjuntoA[i]=0;
            }
            conjuntoA[abs(entrada[i])]=0;
        
        
        }
        
        
         if(i+1 <size && entrada2[i+1]==0 )
        {

            conjuntoB[abs(entrada2[i])]= -1* entrada2[i];
        
        
        }
        else if(i+1==size)
            conjuntoB[abs(entrada2[i])]=-1*entrada2[i];
        
       else if(i>1 && entrada2[i-1]==0)
            conjuntoB[abs(entrada2[i])]=entrada2[i];
        else
        {   if(entrada2[i]==0 && conjuntoB[i]==0)
                conjuntoB[i]=0;
            else
            conjuntoB[abs(entrada2[i])]=0;
        }
    }//fim do for
    
    
    
    
    //ate aqui esta correto
    //verifica se eles nao sao co-tail
    for (i=0; i<size; i++) 
    {
        if(conjuntoA[i]!=conjuntoB[i])
            return 0;
    }
   i=0; 
   int conta_cromossomo=0;
    for (; i<size; i++) {
        
        if (entrada[i]==0) 
	    conta_cromossomo++;
          
    }//fim for
   
    conta_cromossomo++;
    qtd_cromossomo=conta_cromossomo;//setando a quantidade de cromossomos q serve para ambos os genomas A e B
    qtd_genes= (size-qtd_cromossomo)+1;
    free(conjuntoA);
    free(conjuntoB);
    return 1;
}//fim da funcao



//ira conter o status de cada cromossomo do genoma A, indice final onde cada um comeca e termina
int * status_A(int entrada[],int size){
    int i=0;
    int j=0;
    int *estatus2=(int *) calloc (qtd_cromossomo, sizeof (int));
    if (estatus2==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, VALIDAENTRADA.C, LINE 127\n");
    }
    int conta_genes=0;
    int conta_cromossomo=0;
 
    for (; i<size; i++) {
        
        if (entrada[i]==0) {
            estatus2[j]=conta_genes;
            j++;
	    conta_cromossomo++;
            conta_genes=0;
        }
        
        else
        {
            //GENOMA_A[conta_cromossomo][conta_genes]=entrada[i];
             conta_genes++;
        
        }
             
    }//fim for
   
    estatus2[j]=conta_genes;
   i=0;
/*
   for(;i<qtd_cromossomo;i++)
	printf("%d,",estatus2[i]);
    printf("\n");
*/
    return estatus2;

}

int *status_B(int entrada2[],int sizeB)
{
   
    int i=0;
    int B=0;
    
    for (; i<sizeB; i++) {
       
        if(entrada2[i]==0)
            B++;
    }
    
    B++;
 
   int *estatus3=(int *) calloc (B, sizeof (int));
    if (estatus3==NULL) {
        printf("ATENCAO PERCA DE MEMORIA, VALIDAENTRADA.C, LINE 127\n");
    }
     i=0;
    int conta_genesB=0;
    int conta_cromossomoB=0;
    for (; i<sizeB; i++) {
        if (entrada2[i]==0) {
		
            estatus3[conta_cromossomoB]=conta_genesB;	
            conta_cromossomoB++;
            conta_genesB=0;
           
        }
        else
        {
             conta_genesB++;   
        }
        
        
    }//fim for
   
    estatus3[conta_cromossomoB]=conta_genesB;
    
return  estatus3;

}//end function



void load_genoma(int entrada[],int entrada2[],int size, int sizeB)
{
    int i=0;
    int conta_genes=0;
    int conta_genesB=0;
    int conta_cromossomo=0;
    int conta_cromossomoB=0;
   // printf("entrada A:\n");
    for (; i<size; i++) {
        
        if (entrada[i]==0) {
            GENOMA_A[conta_cromossomo][conta_genes]=0;//aqui por enquanto vai ser 0 mais sera pra avaliar se eh circular	
            conta_cromossomo++;
            conta_genes=0;
        }
        
        else
        {
            GENOMA_A[conta_cromossomo][conta_genes]=entrada[i];
             conta_genes++;
        
        }
        
        if (entrada2[i]==0) {
	    GENOMA_B[conta_cromossomoB][conta_genesB]=0;	
            conta_cromossomoB++;
            conta_genesB=0;
           
        }
        else
        {
            GENOMA_B[conta_cromossomoB][conta_genesB]=entrada2[i];
             conta_genesB++;
            
        }
        
        
    }//fim for
   
    GENOMA_B[conta_cromossomoB][conta_genesB]=0;// sobre circularidade
    GENOMA_A[conta_cromossomo][conta_genes]=0;
     i=0;
 
}//fim da funcao

/*
int main(){

   // usa-se o 0 para separar os cromossomos no genoma
    //int entrada[11]={4,3,0,1,2,-7,5,0,6,-8,9};
    //int entrada2[11]={1,2,3,0,4,5,0,6,7,8,9};
    int entrada[17]={1,-2,3,8,4,-5,6,0,7,9,-10,11,-12,13,14,-15,16};
    int entrada2[17]={1,2,3,4,5,6,0,7,8,9,10,11,12,13,14,15,16};
    
  //printf("Saida: %d \n", cromossomo(entrada,entrada2, (sizeof(entrada)/sizeof(int)),(sizeof(entrada2)/sizeof(int))));
 printf("saida:%d\n",is_cotail( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)))); 
 load_genoma( entrada, entrada2,(sizeof(entrada)/sizeof(int)), (sizeof(entrada2)/sizeof(int)));
    return 0;
}



*/


